#define _POSIX_SOURCE 20171300L

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

#define PATH_AGETTY "/sbin/agetty2"

struct tty {
	const char *port;
	pid_t pid;
} tty[4];


void agetty(int idx, const char *port)
{
	tty[idx].port = port;
        tty[idx].pid = fork();
        if (tty[idx].pid == 0) {
                printf("Starting agetty %s...\n", port);
                execl(PATH_AGETTY, PATH_AGETTY, "--noclear", port, "linux", NULL);

                fprintf(stderr, "ERROR agetty!\n");
                _exit(1);
        }
}

void handle_sigint(int signo)
{
        printf("SHOULD REBOOT NOW !!!\n");
}

int main(int argc, char **argv)
{
        struct sigaction sa;
	pid_t wpid;
	int status;

        memset(&sa, 0, sizeof sa);
        sa.sa_handler = handle_sigint;
        sigaction(SIGINT, &sa, 0);

        memset(tty, 0, sizeof tty);

	/* TADY */
        agetty(0, "tty1");
	/* TADY */

        agetty(1, "tty2");
        agetty(2, "tty3");
        agetty(3, "tty4");

        /*if (fork() == 0)
                execl("/etc/rc", "/etc/rc", NULL);
	*/
        for (;;) {
		wpid = waitpid(-1, &status, 0);
		for (int i = 0; i < 4; i++)
			if (wpid == tty[i].pid) {
				printf("restarting %s\n", tty[i].port);
				agetty(i, tty[i].port);
				continue;
			}
		printf("collected child: pid=%d\n", wpid);
        }
}
